* Program.: Demo2.prg
* Author..: Fred C. Wampler
* Date....: Sat  09-24-1988
* Notice..: Copyright 1988, Fred C. Wampler
* -----------------------------------------
* Notes...: Program to TEST skrol.fox (skroldmo.fox)
* skrol.fox returns a (.t.) or (.f.) depending on user selection.
* Skrol.fox presents a dynamic menu to the user.  Information is
* presented to the user in a scrollable window.  Information is taken
* directly from the specified workarea and memory arrays are not used
* unlike other programs.  This allows very large databases to be used.
* Scroll provides automatic index support.  For subfield searches, the
* index can be "toggled-off".  The user selects the menu item by highlighting
* it and pressing "Enter", ^End, or ^W.  To abort the user presses ^Q or
* Esc.  A (.t.) or (.f.) is returned depending on which action is taken.
*
* Keys of interest are the:
* home, end, uparrow,  downarrow, greyplus, greyminus, pageup, pagedown,
* ins, del, enter, F1 (Help).  skroldmo (demo) is identical to skrol.fox
* except that every third time (on-average) F1 (HELP) is pressed,
* ordering information is displayed for 15 secs and numeric keys are not
* supported.  The following program demonstrates some of the capabilities
* and the flexibility of this program.  Incidently, skroldmo returns to
* the calling workarea automatically upon exiting.
* USEAGE:
* IF skroldmo([key],[fields to display],[workarea],rowupper,colleft,rowlower,
*   colright,[menu header])
* ENDIF
* The main point to remember is that an ALIAS must be passed.  Therefore the
* workareas must be opened to begin with.  Also any workarea can be called
* from any other workarea and be returned to the calling area automatically.
*************
IF (.f.)
  Structure for database: EXPCODE.DBF
  Number of data records:     114
  Date of last update   : 09/28/88
  Field  Field Name  Type       Width    Dec
      1  CODE        Character      7
      2  DESC        Character     30
      3  FNAME       Character      8
      4  CREDITBAL   Numeric       11      2
      5  DEBITBAL    Numeric       11      2
      6  TCREDBAL    Numeric       11      2
      7  TDEBITBAL   Numeric       11      2
  ** Total **                      90
ENDIF
*************
CLOSE DATA
SELE 0
USE expcode alias codeon
INDEX ON UPPER(DESC) TO code
SELE 0
USE vendor alias company
INDEX ON UPPER(company) TO company
SELE 0
USE                  && notice no DATABASE open in this area.
CLEAR
* work with workarea CODEON first.
IF skroldmo([TAX],[upper(desc)+' '+code],;
  [codeon],4,30,22,70,[Area seleced CODEON])
  CLEAR
  @ 3,3 SAY [CODE        ]+codeon->code
  @ 4,3 SAY [Description ]+codeon->DESC
ELSE
  CLEAR
  @ 8,0
  ? [NOTHING WAS SELECTED.  FALSE WAS RETURNED]
ENDIF
IF DBF()==SPACE(0)
  ? [No database in use.]
ELSE
  ? DBF(),[in use.]
ENDIF
j=INKEY(10)
CLEAR
* now do not pass a key value.  Toggle the del key
IF skroldmo([],[upper(desc)+' '+code],;
  [codeon],4,30,22,70,[Area seleced CODEON])
  CLEAR
  @ 3,3 SAY [CODE        ]+codeon->code
  @ 4,3 SAY [Description ]+codeon->DESC
ELSE
  CLEAR
  @ 8,0
  ? [Nothing was selected. FALSE was returned]
ENDIF
IF DBF()==SPACE(0)
  ? [No database in use.]
ELSE
  ? DBF(),[in use.]
ENDIF
j=INKEY(10)
CLEAR
* turn index off but leave key set to TAX, also call from another WA.
SELE codeon
SET INDEX TO
SELE company          && now SELECT an entirely different work area.
IF skroldmo([TAX],[upper(desc)+' '+code],;
  [codeon],4,30,22,70,[Area seleced CODEON])
  CLEAR
  @ 3,3 SAY [CODE        ]+codeon->code
  @ 4,3 SAY [Description ]+codeon->DESC
ELSE
  CLEAR
  @ 8,0
  ? [NOTHING WAS SELECTED.  FALSE WAS RETURNED]
ENDIF
IF DBF()==SPACE(0)
  ? [No database in use.]
ELSE
  ? DBF(),[in use.]
ENDIF
j=INKEY(10)
CLOSE DATA
RETURN
